-- Do not edit.  Generated on Mon Jun 29 17:15:39 2020 by tgingold
-- With Cheby 1.4.dev0 and these options:
--  -i wr2rf_vme_regs.cheby --gen-hdl wr2rf_vme_regs.vhd


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity wr2rf_vme_regs is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- Registers for rf1 vtus
    ctrl_rf1_vtus_i      : in    t_wishbone_master_in;
    ctrl_rf1_vtus_o      : out   t_wishbone_master_out;

    -- Registers for rf2 vtus
    ctrl_rf2_vtus_i      : in    t_wishbone_master_in;
    ctrl_rf2_vtus_o      : out   t_wishbone_master_out;

    -- REG reg1
    ctrl_reg1_o          : out   std_logic_vector(15 downto 0);

    -- REG reg2
    ctrl_reg2_o          : out   std_logic_vector(15 downto 0);

    -- Control register for the system clock
    -- 0: dmtd clock (initial); 1: pll (must be locked)
    init_clock_ctrl_clk_sel_o : out   std_logic;
    -- Reset the system pll
    init_clock_ctrl_mmcm_reset_o : out   std_logic;

    -- Adjust the mmcm shift for the 10Mhz external clock
    -- 1: increase, 0: descrease.  Step: TBD
    init_mmcm_shift_incdec_o : out   std_logic;
    init_mmcm_shift_wr_o : out   std_logic;

    -- Status register for system clock
    -- lock status of the mmcm
    init_clock_status_mmcm_locked_i : in    std_logic;
    -- Shift adjustment in progress
    init_clock_status_shift_busy_i : in    std_logic;

    -- timing io grouping of signals
    -- terminations for UBT
    init_tmg_io_term_o   : out   std_logic_vector(3 downto 0);
    -- Output enable for general IO signals (not clocks)
    init_tmg_io_oe_o     : out   std_logic_vector(3 downto 0);
    -- terminations for UBT
    init_tmg_clk_term_o  : out   std_logic_vector(1 downto 0);
    -- independent bidirectional control for clock outputs
    init_tmg_clk_oe_o    : out   std_logic_vector(1 downto 0);

    -- timing io grouping of signals
    -- 0: input, 1 : output
    init_pin_ctrl_ext_ref_dir_o : out   std_logic;

    -- SPI master for the PLL
    init_pll_spi_i       : in    t_wishbone_master_in;
    init_pll_spi_o       : out   t_wishbone_master_out;

    -- SPI master for RF chips.
    -- cs0: DDS
    -- cs1: IQ DAC 1
    -- cs2: IQ DAC 2

    init_rf_spi_i        : in    t_wishbone_master_in;
    init_rf_spi_o        : out   t_wishbone_master_out;

    -- Firmware update (FAR)
    init_fw_update_i     : in    t_wishbone_master_in;
    init_fw_update_o     : out   t_wishbone_master_out;

    -- Register for RF components
    init_rf_i            : in    t_wishbone_master_in;
    init_rf_o            : out   t_wishbone_master_out;

    -- WR ptp core
    init_wrpc_i          : in    t_wishbone_master_in;
    init_wrpc_o          : out   t_wishbone_master_out
  );
end wr2rf_vme_regs;

architecture syn of wr2rf_vme_regs is
  signal adr_int                        : std_logic_vector(18 downto 1);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal ctrl_rf1_vtus_re               : std_logic;
  signal ctrl_rf1_vtus_we               : std_logic;
  signal ctrl_rf1_vtus_wt               : std_logic;
  signal ctrl_rf1_vtus_rt               : std_logic;
  signal ctrl_rf1_vtus_tr               : std_logic;
  signal ctrl_rf1_vtus_wack             : std_logic;
  signal ctrl_rf1_vtus_rack             : std_logic;
  signal ctrl_rf2_vtus_re               : std_logic;
  signal ctrl_rf2_vtus_we               : std_logic;
  signal ctrl_rf2_vtus_wt               : std_logic;
  signal ctrl_rf2_vtus_rt               : std_logic;
  signal ctrl_rf2_vtus_tr               : std_logic;
  signal ctrl_rf2_vtus_wack             : std_logic;
  signal ctrl_rf2_vtus_rack             : std_logic;
  signal ctrl_reg1_reg                  : std_logic_vector(15 downto 0);
  signal ctrl_reg1_wreq                 : std_logic;
  signal ctrl_reg1_wack                 : std_logic;
  signal ctrl_reg2_reg                  : std_logic_vector(15 downto 0);
  signal ctrl_reg2_wreq                 : std_logic;
  signal ctrl_reg2_wack                 : std_logic;
  signal init_clock_ctrl_clk_sel_reg    : std_logic;
  signal init_clock_ctrl_mmcm_reset_reg : std_logic;
  signal init_clock_ctrl_wreq           : std_logic;
  signal init_clock_ctrl_wack           : std_logic;
  signal init_mmcm_shift_incdec_reg     : std_logic;
  signal init_mmcm_shift_wreq           : std_logic;
  signal init_mmcm_shift_wack           : std_logic;
  signal init_tmg_io_term_reg           : std_logic_vector(3 downto 0);
  signal init_tmg_io_oe_reg             : std_logic_vector(3 downto 0);
  signal init_tmg_clk_term_reg          : std_logic_vector(1 downto 0);
  signal init_tmg_clk_oe_reg            : std_logic_vector(1 downto 0);
  signal init_tmg_wreq                  : std_logic;
  signal init_tmg_wack                  : std_logic;
  signal init_pin_ctrl_ext_ref_dir_reg  : std_logic;
  signal init_pin_ctrl_wreq             : std_logic;
  signal init_pin_ctrl_wack             : std_logic;
  signal init_pll_spi_re                : std_logic;
  signal init_pll_spi_we                : std_logic;
  signal init_pll_spi_wt                : std_logic;
  signal init_pll_spi_rt                : std_logic;
  signal init_pll_spi_tr                : std_logic;
  signal init_pll_spi_wack              : std_logic;
  signal init_pll_spi_rack              : std_logic;
  signal init_rf_spi_re                 : std_logic;
  signal init_rf_spi_we                 : std_logic;
  signal init_rf_spi_wt                 : std_logic;
  signal init_rf_spi_rt                 : std_logic;
  signal init_rf_spi_tr                 : std_logic;
  signal init_rf_spi_wack               : std_logic;
  signal init_rf_spi_rack               : std_logic;
  signal init_fw_update_re              : std_logic;
  signal init_fw_update_we              : std_logic;
  signal init_fw_update_wt              : std_logic;
  signal init_fw_update_rt              : std_logic;
  signal init_fw_update_tr              : std_logic;
  signal init_fw_update_wack            : std_logic;
  signal init_fw_update_rack            : std_logic;
  signal init_rf_re                     : std_logic;
  signal init_rf_we                     : std_logic;
  signal init_rf_wt                     : std_logic;
  signal init_rf_rt                     : std_logic;
  signal init_rf_tr                     : std_logic;
  signal init_rf_wack                   : std_logic;
  signal init_rf_rack                   : std_logic;
  signal init_wrpc_re                   : std_logic;
  signal init_wrpc_we                   : std_logic;
  signal init_wrpc_wt                   : std_logic;
  signal init_wrpc_rt                   : std_logic;
  signal init_wrpc_tr                   : std_logic;
  signal init_wrpc_wack                 : std_logic;
  signal init_wrpc_rack                 : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(15 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(18 downto 1);
  signal wr_dat_d0                      : std_logic_vector(15 downto 0);
  signal wr_sel_d0                      : std_logic_vector(1 downto 0);
begin

  -- WB decode signals
  adr_int <= wb_i.adr(18 downto 1);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wr_req_d0 <= '0';
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat(15 downto 0) <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat(15 downto 0);
        wr_sel_d0 <= wb_i.sel(1 downto 0);
      end if;
    end if;
  end process;

  -- Interface ctrl_rf1_vtus
  ctrl_rf1_vtus_tr <= ctrl_rf1_vtus_wt or ctrl_rf1_vtus_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ctrl_rf1_vtus_rt <= '0';
        ctrl_rf1_vtus_wt <= '0';
      else
        ctrl_rf1_vtus_rt <= (ctrl_rf1_vtus_rt or ctrl_rf1_vtus_re) and not ctrl_rf1_vtus_rack;
        ctrl_rf1_vtus_wt <= (ctrl_rf1_vtus_wt or ctrl_rf1_vtus_we) and not ctrl_rf1_vtus_wack;
      end if;
    end if;
  end process;
  ctrl_rf1_vtus_o.cyc <= ctrl_rf1_vtus_tr;
  ctrl_rf1_vtus_o.stb <= ctrl_rf1_vtus_tr;
  ctrl_rf1_vtus_wack <= ctrl_rf1_vtus_i.ack and ctrl_rf1_vtus_wt;
  ctrl_rf1_vtus_rack <= ctrl_rf1_vtus_i.ack and ctrl_rf1_vtus_rt;
  ctrl_rf1_vtus_o.adr <= ((22 downto 0 => '0') & adr_int(8 downto 1)) & (0 downto 0 => '0');
  ctrl_rf1_vtus_o.sel(1 downto 0) <= wr_sel_d0;
  ctrl_rf1_vtus_o.we <= ctrl_rf1_vtus_wt;
  ctrl_rf1_vtus_o.dat(15 downto 0) <= wr_dat_d0;

  -- Interface ctrl_rf2_vtus
  ctrl_rf2_vtus_tr <= ctrl_rf2_vtus_wt or ctrl_rf2_vtus_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ctrl_rf2_vtus_rt <= '0';
        ctrl_rf2_vtus_wt <= '0';
      else
        ctrl_rf2_vtus_rt <= (ctrl_rf2_vtus_rt or ctrl_rf2_vtus_re) and not ctrl_rf2_vtus_rack;
        ctrl_rf2_vtus_wt <= (ctrl_rf2_vtus_wt or ctrl_rf2_vtus_we) and not ctrl_rf2_vtus_wack;
      end if;
    end if;
  end process;
  ctrl_rf2_vtus_o.cyc <= ctrl_rf2_vtus_tr;
  ctrl_rf2_vtus_o.stb <= ctrl_rf2_vtus_tr;
  ctrl_rf2_vtus_wack <= ctrl_rf2_vtus_i.ack and ctrl_rf2_vtus_wt;
  ctrl_rf2_vtus_rack <= ctrl_rf2_vtus_i.ack and ctrl_rf2_vtus_rt;
  ctrl_rf2_vtus_o.adr <= ((22 downto 0 => '0') & adr_int(8 downto 1)) & (0 downto 0 => '0');
  ctrl_rf2_vtus_o.sel(1 downto 0) <= wr_sel_d0;
  ctrl_rf2_vtus_o.we <= ctrl_rf2_vtus_wt;
  ctrl_rf2_vtus_o.dat(15 downto 0) <= wr_dat_d0;

  -- Register ctrl_reg1
  ctrl_reg1_o <= ctrl_reg1_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ctrl_reg1_reg <= "0000000000000000";
        ctrl_reg1_wack <= '0';
      else
        if ctrl_reg1_wreq = '1' then
          ctrl_reg1_reg <= wr_dat_d0;
        end if;
        ctrl_reg1_wack <= ctrl_reg1_wreq;
      end if;
    end if;
  end process;

  -- Register ctrl_reg2
  ctrl_reg2_o <= ctrl_reg2_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ctrl_reg2_reg <= "0000000000000000";
        ctrl_reg2_wack <= '0';
      else
        if ctrl_reg2_wreq = '1' then
          ctrl_reg2_reg <= wr_dat_d0;
        end if;
        ctrl_reg2_wack <= ctrl_reg2_wreq;
      end if;
    end if;
  end process;

  -- Register init_clock_ctrl
  init_clock_ctrl_clk_sel_o <= init_clock_ctrl_clk_sel_reg;
  init_clock_ctrl_mmcm_reset_o <= init_clock_ctrl_mmcm_reset_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_clock_ctrl_clk_sel_reg <= '0';
        init_clock_ctrl_mmcm_reset_reg <= '1';
        init_clock_ctrl_wack <= '0';
      else
        if init_clock_ctrl_wreq = '1' then
          init_clock_ctrl_clk_sel_reg <= wr_dat_d0(0);
          init_clock_ctrl_mmcm_reset_reg <= wr_dat_d0(1);
        end if;
        init_clock_ctrl_wack <= init_clock_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Register init_mmcm_shift
  init_mmcm_shift_incdec_o <= init_mmcm_shift_incdec_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_mmcm_shift_incdec_reg <= '0';
        init_mmcm_shift_wack <= '0';
      else
        if init_mmcm_shift_wreq = '1' then
          init_mmcm_shift_incdec_reg <= wr_dat_d0(0);
        end if;
        init_mmcm_shift_wack <= init_mmcm_shift_wreq;
      end if;
    end if;
  end process;
  init_mmcm_shift_wr_o <= init_mmcm_shift_wack;

  -- Register init_clock_status

  -- Register init_tmg
  init_tmg_io_term_o <= init_tmg_io_term_reg;
  init_tmg_io_oe_o <= init_tmg_io_oe_reg;
  init_tmg_clk_term_o <= init_tmg_clk_term_reg;
  init_tmg_clk_oe_o <= init_tmg_clk_oe_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_tmg_io_term_reg <= "0000";
        init_tmg_io_oe_reg <= "0000";
        init_tmg_clk_term_reg <= "00";
        init_tmg_clk_oe_reg <= "00";
        init_tmg_wack <= '0';
      else
        if init_tmg_wreq = '1' then
          init_tmg_io_term_reg <= wr_dat_d0(3 downto 0);
          init_tmg_io_oe_reg <= wr_dat_d0(7 downto 4);
          init_tmg_clk_term_reg <= wr_dat_d0(9 downto 8);
          init_tmg_clk_oe_reg <= wr_dat_d0(11 downto 10);
        end if;
        init_tmg_wack <= init_tmg_wreq;
      end if;
    end if;
  end process;

  -- Register init_pin_ctrl
  init_pin_ctrl_ext_ref_dir_o <= init_pin_ctrl_ext_ref_dir_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_pin_ctrl_ext_ref_dir_reg <= '0';
        init_pin_ctrl_wack <= '0';
      else
        if init_pin_ctrl_wreq = '1' then
          init_pin_ctrl_ext_ref_dir_reg <= wr_dat_d0(0);
        end if;
        init_pin_ctrl_wack <= init_pin_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Interface init_pll_spi
  init_pll_spi_tr <= init_pll_spi_wt or init_pll_spi_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_pll_spi_rt <= '0';
        init_pll_spi_wt <= '0';
      else
        init_pll_spi_rt <= (init_pll_spi_rt or init_pll_spi_re) and not init_pll_spi_rack;
        init_pll_spi_wt <= (init_pll_spi_wt or init_pll_spi_we) and not init_pll_spi_wack;
      end if;
    end if;
  end process;
  init_pll_spi_o.cyc <= init_pll_spi_tr;
  init_pll_spi_o.stb <= init_pll_spi_tr;
  init_pll_spi_wack <= init_pll_spi_i.ack and init_pll_spi_wt;
  init_pll_spi_rack <= init_pll_spi_i.ack and init_pll_spi_rt;
  init_pll_spi_o.adr <= ((26 downto 0 => '0') & adr_int(4 downto 1)) & (0 downto 0 => '0');
  init_pll_spi_o.sel(1 downto 0) <= wr_sel_d0;
  init_pll_spi_o.we <= init_pll_spi_wt;
  init_pll_spi_o.dat(15 downto 0) <= wr_dat_d0;

  -- Interface init_rf_spi
  init_rf_spi_tr <= init_rf_spi_wt or init_rf_spi_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_rf_spi_rt <= '0';
        init_rf_spi_wt <= '0';
      else
        init_rf_spi_rt <= (init_rf_spi_rt or init_rf_spi_re) and not init_rf_spi_rack;
        init_rf_spi_wt <= (init_rf_spi_wt or init_rf_spi_we) and not init_rf_spi_wack;
      end if;
    end if;
  end process;
  init_rf_spi_o.cyc <= init_rf_spi_tr;
  init_rf_spi_o.stb <= init_rf_spi_tr;
  init_rf_spi_wack <= init_rf_spi_i.ack and init_rf_spi_wt;
  init_rf_spi_rack <= init_rf_spi_i.ack and init_rf_spi_rt;
  init_rf_spi_o.adr <= ((26 downto 0 => '0') & adr_int(4 downto 1)) & (0 downto 0 => '0');
  init_rf_spi_o.sel(1 downto 0) <= wr_sel_d0;
  init_rf_spi_o.we <= init_rf_spi_wt;
  init_rf_spi_o.dat(15 downto 0) <= wr_dat_d0;

  -- Interface init_fw_update
  init_fw_update_tr <= init_fw_update_wt or init_fw_update_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_fw_update_rt <= '0';
        init_fw_update_wt <= '0';
      else
        init_fw_update_rt <= (init_fw_update_rt or init_fw_update_re) and not init_fw_update_rack;
        init_fw_update_wt <= (init_fw_update_wt or init_fw_update_we) and not init_fw_update_wack;
      end if;
    end if;
  end process;
  init_fw_update_o.cyc <= init_fw_update_tr;
  init_fw_update_o.stb <= init_fw_update_tr;
  init_fw_update_wack <= init_fw_update_i.ack and init_fw_update_wt;
  init_fw_update_rack <= init_fw_update_i.ack and init_fw_update_rt;
  init_fw_update_o.adr <= ((30 downto 0 => '0') & adr_int(0 downto 1)) & (0 downto 0 => '0');
  init_fw_update_o.sel(1 downto 0) <= wr_sel_d0;
  init_fw_update_o.we <= init_fw_update_wt;
  init_fw_update_o.dat(15 downto 0) <= wr_dat_d0;

  -- Interface init_rf
  init_rf_tr <= init_rf_wt or init_rf_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_rf_rt <= '0';
        init_rf_wt <= '0';
      else
        init_rf_rt <= (init_rf_rt or init_rf_re) and not init_rf_rack;
        init_rf_wt <= (init_rf_wt or init_rf_we) and not init_rf_wack;
      end if;
    end if;
  end process;
  init_rf_o.cyc <= init_rf_tr;
  init_rf_o.stb <= init_rf_tr;
  init_rf_wack <= init_rf_i.ack and init_rf_wt;
  init_rf_rack <= init_rf_i.ack and init_rf_rt;
  init_rf_o.adr <= ((26 downto 0 => '0') & adr_int(4 downto 1)) & (0 downto 0 => '0');
  init_rf_o.sel(1 downto 0) <= wr_sel_d0;
  init_rf_o.we <= init_rf_wt;
  init_rf_o.dat(15 downto 0) <= wr_dat_d0;

  -- Interface init_wrpc
  init_wrpc_tr <= init_wrpc_wt or init_wrpc_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        init_wrpc_rt <= '0';
        init_wrpc_wt <= '0';
      else
        init_wrpc_rt <= (init_wrpc_rt or init_wrpc_re) and not init_wrpc_rack;
        init_wrpc_wt <= (init_wrpc_wt or init_wrpc_we) and not init_wrpc_wack;
      end if;
    end if;
  end process;
  init_wrpc_o.cyc <= init_wrpc_tr;
  init_wrpc_o.stb <= init_wrpc_tr;
  init_wrpc_wack <= init_wrpc_i.ack and init_wrpc_wt;
  init_wrpc_rack <= init_wrpc_i.ack and init_wrpc_rt;
  init_wrpc_o.adr <= ((14 downto 0 => '0') & adr_int(16 downto 1)) & (0 downto 0 => '0');
  init_wrpc_o.sel(1 downto 0) <= wr_sel_d0;
  init_wrpc_o.we <= init_wrpc_wt;
  init_wrpc_o.dat(15 downto 0) <= wr_dat_d0;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, ctrl_rf1_vtus_wack, ctrl_rf2_vtus_wack, ctrl_reg1_wack, ctrl_reg2_wack, init_clock_ctrl_wack, init_mmcm_shift_wack, init_tmg_wack, init_pin_ctrl_wack, init_pll_spi_wack, init_rf_spi_wack, init_fw_update_wack, init_rf_wack, init_wrpc_wack) begin
    ctrl_rf1_vtus_we <= '0';
    ctrl_rf2_vtus_we <= '0';
    ctrl_reg1_wreq <= '0';
    ctrl_reg2_wreq <= '0';
    init_clock_ctrl_wreq <= '0';
    init_mmcm_shift_wreq <= '0';
    init_tmg_wreq <= '0';
    init_pin_ctrl_wreq <= '0';
    init_pll_spi_we <= '0';
    init_rf_spi_we <= '0';
    init_fw_update_we <= '0';
    init_rf_we <= '0';
    init_wrpc_we <= '0';
    case wr_adr_d0(18 downto 17) is
    when "00" =>
      case wr_adr_d0(16 downto 9) is
      when "00000000" =>
        -- Submap ctrl_rf1_vtus
        ctrl_rf1_vtus_we <= wr_req_d0;
        wr_ack_int <= ctrl_rf1_vtus_wack;
      when "00000001" =>
        -- Submap ctrl_rf2_vtus
        ctrl_rf2_vtus_we <= wr_req_d0;
        wr_ack_int <= ctrl_rf2_vtus_wack;
      when "00000010" =>
        case wr_adr_d0(8 downto 1) is
        when "00000000" =>
          -- Reg ctrl_reg1
          ctrl_reg1_wreq <= wr_req_d0;
          wr_ack_int <= ctrl_reg1_wack;
        when "00000001" =>
          -- Reg ctrl_reg2
          ctrl_reg2_wreq <= wr_req_d0;
          wr_ack_int <= ctrl_reg2_wack;
        when others =>
          wr_ack_int <= wr_req_d0;
        end case;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "10" =>
      case wr_adr_d0(16 downto 5) is
      when "000000000000" =>
        case wr_adr_d0(4 downto 1) is
        when "0000" =>
          -- Reg init_clock_ctrl
          init_clock_ctrl_wreq <= wr_req_d0;
          wr_ack_int <= init_clock_ctrl_wack;
        when "0001" =>
          -- Reg init_mmcm_shift
          init_mmcm_shift_wreq <= wr_req_d0;
          wr_ack_int <= init_mmcm_shift_wack;
        when "0010" =>
          -- Reg init_clock_status
          wr_ack_int <= wr_req_d0;
        when "0011" =>
          -- Reg init_tmg
          init_tmg_wreq <= wr_req_d0;
          wr_ack_int <= init_tmg_wack;
        when "0100" =>
          -- Reg init_pin_ctrl
          init_pin_ctrl_wreq <= wr_req_d0;
          wr_ack_int <= init_pin_ctrl_wack;
        when others =>
          wr_ack_int <= wr_req_d0;
        end case;
      when "000000000001" =>
        -- Submap init_pll_spi
        init_pll_spi_we <= wr_req_d0;
        wr_ack_int <= init_pll_spi_wack;
      when "000000000010" =>
        -- Submap init_rf_spi
        init_rf_spi_we <= wr_req_d0;
        wr_ack_int <= init_rf_spi_wack;
      when "000000000011" =>
        -- Submap init_fw_update
        init_fw_update_we <= wr_req_d0;
        wr_ack_int <= init_fw_update_wack;
      when "000000000100" =>
        -- Submap init_rf
        init_rf_we <= wr_req_d0;
        wr_ack_int <= init_rf_wack;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "11" =>
      -- Submap init_wrpc
      init_wrpc_we <= wr_req_d0;
      wr_ack_int <= init_wrpc_wack;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, ctrl_rf1_vtus_i.dat, ctrl_rf1_vtus_rack, ctrl_rf2_vtus_i.dat, ctrl_rf2_vtus_rack, ctrl_reg1_reg, ctrl_reg2_reg, init_clock_ctrl_clk_sel_reg, init_clock_ctrl_mmcm_reset_reg, init_clock_status_mmcm_locked_i, init_clock_status_shift_busy_i, init_tmg_io_term_reg, init_tmg_io_oe_reg, init_tmg_clk_term_reg, init_tmg_clk_oe_reg, init_pin_ctrl_ext_ref_dir_reg, init_pll_spi_i.dat, init_pll_spi_rack, init_rf_spi_i.dat, init_rf_spi_rack, init_fw_update_i.dat, init_fw_update_rack, init_rf_i.dat, init_rf_rack, init_wrpc_i.dat, init_wrpc_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    ctrl_rf1_vtus_re <= '0';
    ctrl_rf2_vtus_re <= '0';
    init_pll_spi_re <= '0';
    init_rf_spi_re <= '0';
    init_fw_update_re <= '0';
    init_rf_re <= '0';
    init_wrpc_re <= '0';
    case adr_int(18 downto 17) is
    when "00" =>
      case adr_int(16 downto 9) is
      when "00000000" =>
        -- Submap ctrl_rf1_vtus
        ctrl_rf1_vtus_re <= rd_req_int;
        rd_dat_d0 <= ctrl_rf1_vtus_i.dat(15 downto 0);
        rd_ack_d0 <= ctrl_rf1_vtus_rack;
      when "00000001" =>
        -- Submap ctrl_rf2_vtus
        ctrl_rf2_vtus_re <= rd_req_int;
        rd_dat_d0 <= ctrl_rf2_vtus_i.dat(15 downto 0);
        rd_ack_d0 <= ctrl_rf2_vtus_rack;
      when "00000010" =>
        case adr_int(8 downto 1) is
        when "00000000" =>
          -- Reg ctrl_reg1
          rd_ack_d0 <= rd_req_int;
          rd_dat_d0 <= ctrl_reg1_reg;
        when "00000001" =>
          -- Reg ctrl_reg2
          rd_ack_d0 <= rd_req_int;
          rd_dat_d0 <= ctrl_reg2_reg;
        when others =>
          rd_ack_d0 <= rd_req_int;
        end case;
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "10" =>
      case adr_int(16 downto 5) is
      when "000000000000" =>
        case adr_int(4 downto 1) is
        when "0000" =>
          -- Reg init_clock_ctrl
          rd_ack_d0 <= rd_req_int;
          rd_dat_d0(0) <= init_clock_ctrl_clk_sel_reg;
          rd_dat_d0(1) <= init_clock_ctrl_mmcm_reset_reg;
          rd_dat_d0(15 downto 2) <= (others => '0');
        when "0001" =>
          -- Reg init_mmcm_shift
          rd_ack_d0 <= rd_req_int;
        when "0010" =>
          -- Reg init_clock_status
          rd_ack_d0 <= rd_req_int;
          rd_dat_d0(0) <= init_clock_status_mmcm_locked_i;
          rd_dat_d0(1) <= init_clock_status_shift_busy_i;
          rd_dat_d0(15 downto 2) <= (others => '0');
        when "0011" =>
          -- Reg init_tmg
          rd_ack_d0 <= rd_req_int;
          rd_dat_d0(3 downto 0) <= init_tmg_io_term_reg;
          rd_dat_d0(7 downto 4) <= init_tmg_io_oe_reg;
          rd_dat_d0(9 downto 8) <= init_tmg_clk_term_reg;
          rd_dat_d0(11 downto 10) <= init_tmg_clk_oe_reg;
          rd_dat_d0(15 downto 12) <= (others => '0');
        when "0100" =>
          -- Reg init_pin_ctrl
          rd_ack_d0 <= rd_req_int;
          rd_dat_d0(0) <= init_pin_ctrl_ext_ref_dir_reg;
          rd_dat_d0(15 downto 1) <= (others => '0');
        when others =>
          rd_ack_d0 <= rd_req_int;
        end case;
      when "000000000001" =>
        -- Submap init_pll_spi
        init_pll_spi_re <= rd_req_int;
        rd_dat_d0 <= init_pll_spi_i.dat(15 downto 0);
        rd_ack_d0 <= init_pll_spi_rack;
      when "000000000010" =>
        -- Submap init_rf_spi
        init_rf_spi_re <= rd_req_int;
        rd_dat_d0 <= init_rf_spi_i.dat(15 downto 0);
        rd_ack_d0 <= init_rf_spi_rack;
      when "000000000011" =>
        -- Submap init_fw_update
        init_fw_update_re <= rd_req_int;
        rd_dat_d0 <= init_fw_update_i.dat(15 downto 0);
        rd_ack_d0 <= init_fw_update_rack;
      when "000000000100" =>
        -- Submap init_rf
        init_rf_re <= rd_req_int;
        rd_dat_d0 <= init_rf_i.dat(15 downto 0);
        rd_ack_d0 <= init_rf_rack;
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "11" =>
      -- Submap init_wrpc
      init_wrpc_re <= rd_req_int;
      rd_dat_d0 <= init_wrpc_i.dat(15 downto 0);
      rd_ack_d0 <= init_wrpc_rack;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
